<?

///////////////////////////////////////////////////////////////////////////////
class CConnection {
  var $host;
  var $db;
  var $user;
  var $pwd;
  var $name;

  function CConnection($host, $db, $user, $pwd, $name = '') {
    $this->host = $host;
    $this->db = $db;
    $this->user = $user;
    $this->pwd = $pwd;
    $this->name = $name;
  }

  function connect() {
    return sql_connect($this->host, $this->user, $this->pwd, $this->db);
  }  

  function disconnect() {
    return sql_disconnect();
  }
};

///////////////////////////////////////////////////////////////////////////////
class CConnectionManager {
  // public variables
  var $connections;

  // private variables
  var $currentConnection = 0;
  var $connected = false;
  var $savedConnection = 0;

  function CConnectionManager() {
  }

  function connect($n = -1) {
    if ($n < 0) {
      $n = $this->currentConnection;
    } else {
      $this->currentConnection = $n;
    }
    
    if ($this->connected)
      $this->connections[$n]->disconnect();
    
    $this->connected = $this->connections[$n]->connect();

    return $this->connected;
  }

  function disconnect() {
    if (count($connections) > 0)
      $this->connections[0]->disconnect();
  }

  function addConnection($host, $db, $user, $pwd) {
    $this->connections[] = new CConnection($host, $db, $user, $pwd);
  }

  function connectNext() {
    $this->currentConnection = ($this->currentConnection + 1)
                               % count($this->connections);
    $this->connect();
    
    return $this->currentConnection;
  }

  function saveConnection() {
    $this->saveConnection = $this->currentConnection;
  }

  function restoreConnection() {
    $this->connect($this->saveConnection);
  }
};

?>
