<?
class CLogin {
  var $tpl;
  var $loginVar = 'loginName';
  var $passwordVar = 'loginPassword';
  var $hashPasswordVar = 'loginHashPassword';
  var $sessionKeyVar = 'loginSessionKey';
  var $formName = 'loginForm';
  var $loginDuration = 3600;              // default login duration is 1 hour
  var $moreForm = '';
  var $personsTable;
  var $sessionsTable;
  
  ///////////////////////////////////////////////////////////////////////////
  function CLogin($tablesPrefix = 'login_') {
    $this->tpl = new CTemplate();
    $this->tpl->tpl['main'] = '
      <table>
        <form method="post" name="{FORMNAME}">
        {MOREFORM}
        <tr>
          <td>Login</td>
          <td><input type="text" name="{LOGINVAR}" value="{LOGIN}"></td>
        </tr>
        <tr>
          <td>Mot de passe</td>
          <td><input type="password" name="{PASSWORDVAR}" value="{PASSWORD}"></td>
        </tr>
        <tr>
          <td colspan=2 align="right"><input type="submit" value="  ok  " onClick="onSubmit{FORMNAME}()"></td>
        </tr>
        <input type="hidden" name="{HASHPASWORDVAR}">
        </form>
      </table>
      <script language="JavaScript">
      <!--
        function onSubmit{FORMNAME}() {
          document.forms[\'{FORMNAME}\'].{HASHPASWORDVAR}.value = hex_md5(document.forms[\'{FORMNAME}\'].{PASSWORDVAR}.value);
          document.forms[\'{FORMNAME}\'].{PASSWORDVAR}.value = "";
          document.forms[\'{FORMNAME}\'].submit();
        }
      -->
      </script>';
    $this->setTablesPrefix($tablesPrefix);
  }

  ///////////////////////////////////////////////////////////////////////////
  function createTables() {
    sql_query("CREATE TABLE {$this->personsTable} (id mediumint(8) unsigned NOT NULL auto_increment,
                                                   login varchar(255) NOT NULL default '',
                                                   password varchar(255) NOT NULL default '',
                                                   PRIMARY KEY (id)) TYPE=MyISAM");
    sql_query("CREATE TABLE {$this->sessionsTable} (login_id mediumint(8) unsigned NOT NULL default '0',
                                                    end int(10) unsigned NOT NULL default '0',
                                                    `key` varchar(255) NOT NULL default '',
                                                    PRIMARY KEY (login_id)) TYPE=MyISAM");
  }

  ///////////////////////////////////////////////////////////////////////////
  function setTablesPrefix($prefix) {
    $this->personsTable = $prefix . 'persons';
    $this->sessionsTable = $prefix . 'sessions';
  }
  
  ///////////////////////////////////////////////////////////////////////////
  function addUser($login, $hashPassword) {
    $login = sql_prepare_str($login, true);
    $hashPassword = sql_prepare_str($hashPassword, true);
    return sql_query("INSERT INTO {$this->personsTable} (login, password) VALUES ('$login', '$hashPassword')");
  }

  ///////////////////////////////////////////////////////////////////////////
  function deleteUser($id) {
    return sql_query("DELETE FROM {$this->personsTable} WHERE id = $id");
  }
  
  ///////////////////////////////////////////////////////////////////////////
  function renderForm() {
    return $this->tpl->compile('main', array('{LOGINVAR}' => $this->loginVar,
                                             '{LOGIN}' => '',
                                             '{PASSWORDVAR}' => $this->passwordVar,
                                             '{PASSWORD}' => '',
                                             '{FORMNAME}' => $this->formName,
                                             '{HASHPASWORDVAR}' => $this->hashPasswordVar,
                                             '{MOREFORM}' => $this->moreForm));
  }

  ///////////////////////////////////////////////////////////////////////////
  // returns login ID if login is ok, 0 else
  function verifyLogin() {
    $login = sql_prepare_str($GLOBALS[$this->loginVar], true);
    $password = sql_prepare_str($GLOBALS[$this->hashPasswordVar], true);

    // see if login/password combination is ok
    $req = "SELECT id FROM {$this->personsTable} WHERE login = '$login' AND password = '$password'";
    $res = sql_query($req);
    if ($row = sql_fetch_row($res)) {
      return $row[0];
    }
    return 0;
  }

  ///////////////////////////////////////////////////////////////////////////
  function login() {
    if (($id = $this->verifyLogin()) != 0) {
      // see if a user has a valid session
      $req = "SELECT end, UNIX_TIMESTAMP(), `key` FROM {$this->sessionsTable} WHERE login_id = $id";
      $res = sql_query($req);
      if ($row = sql_fetch_row($res)) {
        if ($row[0] > $row[1]) {
          // session is still valid, simply register it
          $this->sessionRegister($row[2]);
          return true;
        }
      }
      
      // create a new session
      $this->createSession($id);

      return $id;
    }

    return false;
  }

  ///////////////////////////////////////////////////////////////////////////
  function sessionRegister($key) {
    $GLOBALS[$this->sessionKeyVar] = $key;
    session_register($this->sessionKeyVar);
  }

  ///////////////////////////////////////////////////////////////////////////
  function createSession($id) {
    // generate a unike key
    do {
      $key = md5(uniqid("blourglou", 1));
      $cond = " WHERE `key` = '$key'";
    } while (sql_count($this->sessionsTable, $cond) != 0);

    $key = sql_prepare_str($key, false);

    // create/update session in db
    $req = "SELECT COUNT(*) FROM {$this->sessionsTable} WHERE login_id = $id";
    $res = sql_query($req);
    $row = sql_fetch_row($res);
    
    if ($row[0] == 0) {
      // insert a new session
      $req = "INSERT INTO {$this->sessionsTable} (login_id, end, `key`) VALUES ($id, UNIX_TIMESTAMP() + {$this->loginDuration}, '$key')";
    } else {
      // update session
      $req = "UPDATE {$this->sessionsTable} SET end = UNIX_TIMESTAMP() + {$this->loginDuration}, `key` = '$key' WHERE login_id = $id";
    }
    sql_query($req);

    // register session
    $this->sessionRegister($key);
  }

  ///////////////////////////////////////////////////////////////////////////
  function logout() {
    global $HTTP_SESSION_VARS;
    
    // make session invalid
    $key = sql_prepare_str($HTTP_SESSION_VARS[$this->sessionKeyVar], false);
    
    $req = "UPDATE {$this->sessionsTable} SET end = 0 WHERE `key` = '$key'";
    sql_query($req);

    session_unregister($this->sessionKeyVar);
  }

  ///////////////////////////////////////////////////////////////////////////
  // return true if the session is ok ; assumes that session has been 
  // initialised
  function isLogged() {
    global $HTTP_SESSION_VARS;

    $key = sql_prepare_str($HTTP_SESSION_VARS[$this->sessionKeyVar], false);
    
    $req = "SELECT end, UNIX_TIMESTAMP() FROM {$this->sessionsTable} WHERE `key` = '$key'";
    $res = sql_query($req);
    
    if ($res) {    
      if ($row = sql_fetch_row($res)) {
        return ($row[0] > $row[1]);
      }
    }
    
    return false;
  }
};
?>
